from __future__ import absolute_import
from __future__ import print_function

from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Components.Label import Label
from Components.ActionMap import ActionMap
from Screens.MessageBox import MessageBox
from Components.ConfigList import ConfigListScreen
from Tools.NumericalTextInput import NumericalTextInput
from Components.config import config, getConfigListEntry, ConfigPassword, ConfigText, ConfigSelection, ConfigSubsection, ConfigYesNo
from http.client import HTTPConnection, CannotSendRequest, BadStatusLine, HTTPException
import urllib.request, urllib.error, urllib.parse
from socket import gaierror, error
import os
import socket
from os import remove, rename, system
import base64
import sys
sessions = []
config.ActivE = ConfigSubsection()
config.ActivE.password = ConfigPassword(default = '', fixed_size = False, censor = '*')
config.ActivE.password.setUseableChars('0123456789')
from Screens.VirtualKeyBoard import VirtualKeyBoard
Meknes_version = '4.1'
Python_version = '3.9'
timeout = 20
socket.setdefaulttimeout(timeout)
x = 0
from Plugins.Extensions.suptv.Options import eConsole

class ActivEScreenMain(ConfigListScreen, Screen):
    skin = """
    <screen position="220,150" size="560,300" title="SupTv 4.1          Satland" >
        <widget name="config" position="30,50" size="480,100" scrollbarMode="showOnDemand" />
        <widget name="key_red" position="30,140" size="200,40" backgroundColor="red" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18" />
        <widget name="key_green" position="30,140" size="200,40" backgroundColor="green" valign="center" halign="center" zPosition="2"  foregroundColor="black" font="Regular;20" />
        <widget name="key_blue" position="310,140" size="200,40" backgroundColor="blue" valign="center" halign="center" zPosition="2"  foregroundColor="black" font="Regular;20"/>
        <widget name="key_yellow" position="310,140" size="200,40" backgroundColor="yellow" valign="center" halign="center" zPosition="2"  foregroundColor="black" font="Regular;20"/>
        <widget name="lab1" position="30,230" halign="center" size="200,100" zPosition="1" font="Regular;20" valign="top" />
        <widget name="lab2" position="300,230" halign="center" size="200,100" zPosition="1" font="Regular;20" valign="top" />
    </screen> """

    def __init__(self, session, args = 0):
        Screen.__init__(self, session)
        self.list = []
        
        self.list.append(getConfigListEntry(_('code:'), config.ActivE.password))
        ConfigListScreen.__init__(self, self.list)
        self['key_green'] = Label(_('Activate'))
        self['key_blue'] = Label(_('Info'))
        self['key_red'] = Label(_('Update'))
        self['key_yellow'] = Label(_('Clavier'))
        self['lab1'] = Label()
        self['lab2'] = Label()
        self.onShow.append(self.updateOk)
        self['actions'] = ActionMap([
            'ActiveCodeActions'], {
            'green': self.green,
            'save': self.green,
            'ok': self.green,
            'blue': self.blue,
            'red': self.red,
            'yellow': self.yellow,
            'exit': self.close,
            'cancel': self.cancel }, -2)
        self['key_red'].hide()
        self['key_blue'].hide()
        self['key_green'].hide()
        self['key_yellow'].hide()
            
    def blue(self):
      
        if not os.path.isfile('/etc/code'):
            pass
        if os.path.isfile('/etc/uniqid'):
            mac1 = open('/sys/class/net/eth0/address', 'r')
            mac0 = mac1.read().rstrip('\n\r')
            mac = mac0.upper()
            code = open('/etc/code', 'r')
            mycode = code.read()
            PATH = '/etc/uniqid'
            if os.path.isfile(PATH) and os.access(PATH, os.R_OK):
                unicid = open('/etc/uniqid', 'r')
                myunicid = unicid.read()
                get_url = 'http://enigma.suptv.me/e2/info.php?co=%s&ma=%s&hash=%s&core=openpli' % (mycode, mac, myunicid)
                
                try:
                    mx = urllib.request.urlopen(get_url)
                    getpage = mx.read()
                    view = getpage.decode('utf-8')
                    self.session.open(MessageBox, view, MessageBox.TYPE_INFO)
                except (urllib.error.URLError, HTTPException, socket.error):
                    self.session.open(MessageBox, 'Connection Error', MessageBox.TYPE_ERROR)

    def green(self):
        if not os.path.isfile('/etc/code'):
            Info = (_('Voulez-vous installer: Les Favoris'))
            message = ((Info ) + ' ?')
            ybox = self.session.openWithCallback(self.installation, MessageBox, message, MessageBox.TYPE_YESNO)
            ybox.setTitle(_('Installation'))    
    
    def red(self):
        #if os.path.isfile('/etc/code'):      
            Info = (_('Voulez-vous installer: Les Favoris'))
            message = ((Info ) + ' ?')
            ybox = self.session.openWithCallback(self.update, MessageBox, message, MessageBox.TYPE_YESNO)
            ybox.setTitle(_('Update'))

    def installation(self, reponse):

        if (reponse is True):
            global x
            x = x + 1        
            mac = open('/sys/class/net/eth0/address', 'r')
            mac0 = mac.read().rstrip('\n\r')
            MyMacAddr = mac0.upper()
            get_url = 'http://enigma.suptv.me/e2/osac.php?co=%s&ma=%s&core=openpli' % (config.ActivE.password.value, MyMacAddr)
                        
            try:
                    mx = urllib.request.urlopen(get_url)
                    getpage = mx.read()
                    view = getpage
                    f = open('/tmp/enigma2.sh', 'w')
                    f.write(view.decode('utf-8'))
                    f.close()
                    Mots = ['libcrypto', 'SupVpn', 'supvod', 'RELOAD', 'SUPAUTO', 'AutoSup']
                    with open('/tmp/enigma2.sh') as Ancien, open('/tmp/enigma.sh', 'w') as Nouveau:
                      for line in Ancien:
                         if not any(Mots in line for Mots in Mots):
                            Nouveau.write(line)
                    system('chmod 755 /tmp/enigma.sh')
                    os.remove('/tmp/enigma2.sh')
                    os.rename('/tmp/enigma.sh', '/tmp/enigma2.sh')
                    cmd = '/tmp/enigma2.sh'
                    if os.path.isfile('/tmp/enigma2.sh'):    
                       taille = os.path.getsize('/tmp/enigma2.sh')
                       if taille == 0 and x == 1:
                          Info = (_("le code saisi est errone.\n\nIl vous reste deux tentatives.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information'))
                       if taille == 0 and x == 2:
                          Info = (_("le code saisi est errone.\n\nIl vous reste une tentative.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information'))
                       if taille == 0 and x == 3:
                          Info = (_("Votre compte est banni.\n\nContacter le support.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information'))
                       if (taille > 0 and taille < 1000000):
                          Info = (_("Votre compte est banni.\n\nContacter le support.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information')) 
                       if taille > 1000000:
                          self.session.open(eConsole, _('Update'), [
                          cmd])
                    
            except (urllib.error.URLError, HTTPException, socket.error):
                    self.session.open(MessageBox, 'Connection Error', MessageBox.TYPE_ERROR)
        else:
            mac = open('/sys/class/net/eth0/address', 'r')
            mac0 = mac.read().rstrip('\n\r')
            MyMacAddr = mac0.upper()
            get_url = 'http://enigma.suptv.me/e2/osac.php?co=%s&ma=%s&core=openpli' % (config.ActivE.password.value, MyMacAddr)
            
            try:
                    mx = urllib.request.urlopen(get_url)
                    getpage = mx.read()
                    view = getpage
                    f = open('/tmp/enigma2.sh', 'w')
                    f.write(view.decode('utf-8'))
                    f.close()
                    Mots = ['etc/enigma2', '#NAME', 'libcrypto', 'SupVpn', 'supvod', 'RELOAD', 'SUPAUTO', 'AutoSup']
                    with open('/tmp/enigma2.sh') as Ancien, open('/tmp/enigma.sh', 'w') as Nouveau:
                         for line in Ancien:
                             if not any(Mots in line for Mots in Mots):
                                Nouveau.write(line)
                    system('chmod 755 /tmp/enigma.sh')
                    os.remove('/tmp/enigma2.sh')
                    os.rename('/tmp/enigma.sh', '/tmp/enigma2.sh')
                    cmd = '/tmp/enigma2.sh'
                    if os.path.isfile('/tmp/enigma2.sh'):    
                       taille = os.path.getsize('/tmp/enigma2.sh')
                       if taille == 0 and x == 1:
                          Info = (_("le code saisi est errone.\n\nIl vous reste deux tentatives.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information'))
                       if taille == 0 and x == 2:
                          Info = (_("le code saisi est errone.\n\nIl vous reste une tentative.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information'))
                       if taille == 0 and x == 3:
                          Info = (_("Votre compte est banni.\n\nContacter le support.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information'))
                       if (taille > 0 and taille < 1000000):
                          Info = (_("Votre compte est banni.\n\nContacter le support.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information')) 
                       if taille > 1000000:
                          self.session.open(eConsole, _('Update'), [
                          cmd])
                    
            except (urllib.error.URLError, HTTPException, socket.error):
                    self.session.open(MessageBox, 'Connection Error', MessageBox.TYPE_ERROR)

    def update(self, reponse):
        if (reponse is True):
            global x
            x = x + 1        
            if not os.path.isfile('/etc/code'):
                pass
            if os.path.isfile('/etc/uniqid'):
                mac = open('/sys/class/net/eth0/address', 'r')
                mac0 = mac.read().rstrip('\n\r')
                MyMacAddr = mac0.upper()
                code = open('/etc/code', 'r')
                mycode = code.read()
                unicid = open('/etc/uniqid', 'r')
                myunicid = unicid.read()
                get_url = 'http://enigma.suptv.me/e2/up.php?co=%s&ma=%s&hash=%s&core=openpli' % (mycode, MyMacAddr, myunicid)
                       
                try:
                    mx = urllib.request.urlopen(get_url)
                    getpage = mx.read()
                    view = getpage
                    f = open('/tmp/enigma2.sh', 'w')
                    f.write(view.decode('utf-8'))
                    f.close()
                    f = open('/tmp/enigma2.sh','a')
                    f. write('killall -9 enigma2')
                    f. close()                    
                    Mots = ['libcrypto', 'reboot', 'SupVpn', 'supvod', 'RELOAD', 'SUPAUTO', 'AutoSup']
                    with open('/tmp/enigma2.sh') as Ancien, open('/tmp/enigma.sh', 'w') as Nouveau:
                         for line in Ancien:
                             if not any(Mots in line for Mots in Mots):
                                Nouveau.write(line)
                    system('chmod 755 /tmp/enigma.sh')
                    os.remove('/tmp/enigma2.sh')
                    os.rename('/tmp/enigma.sh', '/tmp/enigma2.sh')
                    cmd = '/tmp/enigma2.sh'
                    if os.path.isfile('/tmp/enigma2.sh'):    
                       taille = os.path.getsize('/tmp/enigma2.sh')
                       if taille == 0 and x == 1:
                          Info = (_("le code saisi est errone.\n\nIl vous reste deux tentatives.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information'))
                       if taille == 0 and x == 2:
                          Info = (_("le code saisi est errone.\n\nIl vous reste une tentative.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information'))
                       if taille == 0 and x == 3:
                          Info = (_("Votre compte est banni.\n\nContacter le support.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information'))
                       if (taille > 0 and taille < 1000000):
                          Info = (_("Votre compte est banni.\n\nContacter le support.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information')) 
                       if taille > 1000000:
                          self.session.open(eConsole, _('Update'), [
                          cmd])
                    
                except (urllib.error.URLError, HTTPException, socket.error):
                    self.session.open(MessageBox, 'Connection Error', MessageBox.TYPE_ERROR)
        else:
            if not os.path.isfile('/etc/code'):
                pass
            if os.path.isfile('/etc/uniqid'):
                mac = open('/sys/class/net/eth0/address', 'r')
                mac0 = mac.read().rstrip('\n\r')
                MyMacAddr = mac0.upper()
                code = open('/etc/code', 'r')
                mycode = code.read()
                unicid = open('/etc/uniqid', 'r')
                myunicid = unicid.read()
                get_url = 'http://enigma.suptv.me/e2/up.php?co=%s&ma=%s&hash=%s&core=openpli' % (mycode, MyMacAddr, myunicid)
            
                try:
                    mx = urllib.request.urlopen(get_url)
                    getpage = mx.read()
                    view = getpage
                    f = open('/tmp/enigma2.sh', 'w')
                    f.write(view.decode('utf-8'))
                    f.close()
                    f = open('/tmp/enigma2.sh','a')
                    f. write('killall -9 enigma2')
                    f. close()                
                    Mots = ['etc/enigma2', '#NAME', 'libcrypto', 'reboot', 'SupVpn', 'supvod', 'RELOAD', 'SUPAUTO', 'AutoSup']
                    with open('/tmp/enigma2.sh') as Ancien, open('/tmp/enigma.sh', 'w') as Nouveau:
                         for line in Ancien:
                             if not any(Mots in line for Mots in Mots):
                                Nouveau.write(line)
                    system('chmod 755 /tmp/enigma.sh')
                    os.remove('/tmp/enigma2.sh')
                    os.rename('/tmp/enigma.sh', '/tmp/enigma2.sh')
                    cmd = '/tmp/enigma2.sh'
                    if os.path.isfile('/tmp/enigma2.sh'):    
                       taille = os.path.getsize('/tmp/enigma2.sh')
                       if taille == 0 and x == 1:
                          Info = (_("le code saisi est errone.\n\nIl vous reste deux tentatives.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information'))
                       if taille == 0 and x == 2:
                          Info = (_("le code saisi est errone.\n\nIl vous reste une tentative.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information'))
                       if taille == 0 and x == 3:
                          Info = (_("Votre compte est banni.\n\nContacter le support.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information'))
                       if (taille > 0 and taille < 1000000):
                          Info = (_("Votre compte est banni.\n\nContacter le support.\n\nCliquez sur OK pour continuer"))
                          mybox = self.session.open(MessageBox, Info, MessageBox.TYPE_INFO)
                          mybox.setTitle(_('Information')) 
                       if taille > 1000000:
                          self.session.open(eConsole, _('Update'), [
                          cmd])
                                            
                except (urllib.error.URLError, HTTPException, socket.error):
                    self.session.open(MessageBox, 'Connection Error', MessageBox.TYPE_ERROR)
        
    def cancel(self):
        for x in self['config'].list:
            x[1].cancel()
            self.close(False)
        
    def updateOk(self):
        if os.path.isfile('/tmp/code'):
            fe = open('/tmp/code', 'r')
            fe1 = fe.read()
            config.ActivE.password.value = fe1
            fe.close()
        if os.path.isfile('/etc/code'):
            self['key_red'].show()
            self['key_blue'].show()
            self.removeAction("green")            
            self.removeAction("yellow")
            mac1 = open('/sys/class/net/eth0/address', 'r')
            mac0 = mac1.read().rstrip('\n\r')
            mac = mac0.upper()
            code = open('/etc/code', 'r')
            mycode = code.read()
            PATH = '/etc/uniqid'
            if os.path.isfile(PATH) and os.access(PATH, os.R_OK):
                unicid = open('/etc/uniqid', 'r')
                myunicid = unicid.read()
                get_url = 'http://enigma.suptv.me/e2/info.php?co=%s&ma=%s&hash=%s&core=openpli' % (mycode, mac, myunicid)
                                                                                                                       
                try:
                    mx = urllib.request.urlopen(get_url)
                    getpage = mx.read()
                    view = getpage
                    f = open('/etc/info', 'w')
                    f.write(view.decode('utf-8'))
                    f.close()
                except (urllib.error.URLError, HTTPException, socket.error):
                    self.session.open(MessageBox, 'Information impossible', MessageBox.TYPE_ERROR)

            if system('grep Active /etc/info') == 0:
                self['lab1'].setText('Compte: Active')
            if system('grep Invalid /etc/info') == 0:
                system('rm -f /etc/code')
                self.close()
            if system('grep Banni /etc/info') == 0:
                self['lab1'].setText('Compte: Banni')
            if os.path.isfile('/etc/info'):
                f = open('/etc/info', 'r')
                for line in f.readlines():
                    if line.find('Remaining') != -1:
                        line = line.strip()
                        cn = line[10:13]
                        self['lab2'].setText('Jours restants: ' + cn)
                        continue
                    self['lab2'].setText('')
                f.close()
            
        else:
            self['key_green'].show()
            self['key_yellow'].show()
            self.removeAction('red')
            self.removeAction('blue')
            self['lab1'].setText('')
            self['lab2'].setText('')
        system('rm -f /tmp/code')
        system('rm -f /etc/info')
    
    def buildList(self, password):
        config.ActivE.password.value = password
        self.list = []
        self.list.append(getConfigListEntry(_('code'), ConfigText(default = config.ActivE.password.value, fixed_size = False)))
        self['config'].setList(self.list)

    def removeAction(self, descr):
        actions = self["actions"].actions
        if descr in actions:
            del actions[descr]
    
    def yellow(self):
        #if not os.path.isfile('/etc/code'):        
            self.session.openWithCallback(self.VirtualKeyBoardTextEntry, VirtualKeyBoard, title = _('code:'), text = config.ActivE.password.value)
    
    def VirtualKeyBoardTextEntry(self, callback = None):
        if callback is not None and len(callback):
            self.buildList(callback)

def main(session, **kwargs):
    session.open(ActivEScreenMain)

def Plugins(**kwargs):
    return [
        PluginDescriptor(name = 'SupTv Activator', description = 'All In One', where = PluginDescriptor.WHERE_PLUGINMENU, icon = 'Satland.png', fnc = main)]

