#!/bin/sh

###################################
######   Par Meknes    ############
###################################

OSD="SupCam 4.0"
PID=`pidof oscammips`
Action=$1

cam_clean () {
	rm -rf /tmp/.oscam  /tmp/oscam*
}

cam_handle () {
	if test	-z "${PID}"	; then
		cam_up;
	else
		cam_down;
	fi;
}

cam_down ()	{
	killall	-9 oscammips
	sleep 2
	cam_clean
}

cam_up () {
	/usr/local/etc/oscammips -S -c /usr/local/etc &
}

if test	"$Action" =	"cam_res" ;	then
		cam_down
		cam_up
elif test "$Action"	= "cam_down" ; then
		cam_down
elif test "$Action"	= "cam_up" ; then
		cam_up
else
		cam_handle
fi

exit 0
